import { Component, OnInit, ElementRef, AfterViewInit, VERSION, Injectable } from '@angular/core';
import { TokenService, TokenProvider } from '../../services/login/token.service';
import {Router} from '@angular/router';

declare const gapi: any;

declare var $ :any;

import '../../../assets/custom.js';
declare function simple_notifier(type: string, title: string, message:string): any;

@Component({
  selector: 'googgle-sign-in',
  templateUrl: './googgle-sign-in.component.html',
  styleUrls: ['./googgle-sign-in.component.css']
})
export class GooggleSignInComponent implements OnInit, AfterViewInit, Injectable {

  

  constructor(private element: ElementRef, private tokenService : TokenService, private router : Router) {
    
  }

  ngOnInit() {

  }

  ngAfterViewInit() {


    //RE-Render the button (due to known issues of google-button with angular's lifecycle)
    gapi.signin2.render('googleBtn');
    var buttonElement = this.element.nativeElement.querySelector('#googleBtn'); 
    this.attachSignin(buttonElement);
    
  }
  

  
  public attachSignin(element) {

    gapi.auth2.getAuthInstance().attachClickHandler(element, {},
      (googleUser) => {
        //simple_notifier("success",null,"Successful login");
        let profile = googleUser.getBasicProfile();
        this.tokenService.login(googleUser.getAuthResponse().id_token, TokenProvider.google, profile.getName(), profile.getEmail());
      }, 
      function (error) {
        //simple_notifier("danger",null,"Failed to login");
        console.log(JSON.stringify(error, undefined, 2));
      }
    ); 

  }






}


